function PerifericosService(ZHPromise, ScreenService, PrinterService, WindowService) {
	var self = this;

	var header = {
		"Content-Type": "application/json"
	};
	var POST = "POST";

	//Recebe array de parametros para impressao.
	//Cada posicao deve conter informacoes necessarias
	//para realizar uma requisicao ao perifericos.

	this.print = function (params, impressaoPedidoSmart, imprimeNoFor) {
		WindowService.log("call print params: "+JSON.stringify(params));
		var defer = ZHPromise.defer();
		try {
			ScreenService.showLoader();
			counter = 0;
			impressaoPedidoSmart = !_.isEmpty(impressaoPedidoSmart) ? impressaoPedidoSmart : params;
			if (params == false || (_.isEmpty(params) && _.isEmpty(impressaoPedidoSmart))){
				var res = { message: "", error: false };
				defer.resolve(res);
				return defer.promise;
			}
			if(!Array.isArray(params)){
				params = Array(params);
			}
			var promiseArray = Array();
			params.forEach(function(params_,index){
				params[index].IDUTILIMPFRONT = params[index].IDUTILIMPFRONT||false;
				if(params[index].IDUTILIMPFRONT=='S'){params[index].IDUTILIMPFRONT=true;}
				if (!params[index].IDUTILIMPFRONT) {
					var texto = '';
					if ((impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '25' && !!window.cordova && !!cordova.plugins.GertecPrinter) || (impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '27' && !!window.ZhCieloAutomation) || impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '28' || (impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '40' && !!window.ZhStoneAutomation) || (impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '38' && !!window.cordova && !!window.cordova.plugins.IntegrationService)) {
						impressaoPedidoSmart.forEach(function(pedidos){
							pedidos.comandos.forEach(function(comandos){
								counter++;
								texto += comandos.parameters.text;
								if (!!~comandos.parameters.text.search('SENHA')) {
									PrinterService.printerCommand(PrinterService.TEXT_COMMAND, texto);
									PrinterService.printerSpaceCommand(2);
									texto = '';
								}
							});
						});
					}
					if((PrinterService.printerCommands||[]).length>0) {
						PrinterService.printerInit().then(function (result) {
							if (result.error) ScreenService.alertNotification(result.message);
						});
					} else {
						WindowService.log("PrinterService.printerCommands: "+JSON.stringify(PrinterService.printerCommands));
					}
					defer.resolve({message: "",error: false});
					return defer.promise;
				} else {
					if (!Array.isArray(params[index])) {
						if (params[index].comandos) {
							params[index] = [params[index]];
						} else {
							params[index] = _.toArray(params[index]);
						}
					}
					paramsTemp = params[index];
					paramsTemp.map(function (param) {
						if(!(param.impressora.DSIPPONTE)){
							ScreenService.showMessage("Impressora "+(param.impressora.NMIMPRLOJA)+" sem endereço do Perifericos cadastrado.");
						} else {

						if(param.impressora.DSIPPONTE.indexOf('http')<0){
							param.impressora.DSIPPONTE = 'http://'+param.impressora.DSIPPONTE;
						}
						var stDSIPPONTE = param.impressora.DSIPPONTE;
						var url = param.impressora.DSIPPONTE + "/print";
						var body = JSON.stringify({
							printerInfo: {
								printerType: param.impressora.IDMODEIMPRES,
								port: param.impressora.CDPORTAIMPR
							},
							commands: param.comandos
						});
						promiseArray.push(
							fetch(
								url, {
									headers: header,
									method: POST,
									body: body
								}
							).then(function (response) {
								if(response && response.text ){
									return response.text().then(function(r){
										response = r;
										try {
											response = JSON.parse(response);
										} catch (error) {
											response.message = 'Não foi possível comunicar com a impressora.';
											response.error = true;
										}
										if(response.error){
											ScreenService.alertNotification(response.message);
										}
									});
								}
							}).catch(function (error) {
								error.message = 'Não foi possível comunicar com a impressora.';
								ScreenService.alertNotification(error.message);
								self.verificaInsecureContent(stDSIPPONTE);
							})
						);
						}
					});
				}
			});
			return Promise.all(promiseArray);
		} catch (error) {
			if (!_.isEmpty(_.get(params, 'impressora.NMIMPRLOJA'))) {
				error.message = 'Não foi possível comunicar com a impressora.';
			} else {
				error.message = 'Não foi possível comunicar com a impressora.';
			}
			error.error = true;
			defer.reject(error);
			return defer.promise;
		} finally {
			ScreenService.hideLoader();
		}
	};

	this.printTableOrder = function (impressaoPedidoSmart) {
		WindowService.log("call printTableOrder params: "+JSON.stringify(impressaoPedidoSmart));
		var defer = ZHPromise.defer();
		try {
			ScreenService.showLoader();
			if (_.isEmpty(impressaoPedidoSmart)){
				defer.resolve({message:"",error:false});
				return defer.promise;
			}
			if(!Array.isArray(impressaoPedidoSmart)){
				impressaoPedidoSmart = Array(impressaoPedidoSmart);
			}
			var promiseArray = Array();
			impressaoPedidoSmart.forEach(function(impressaoPedidoSmart_,index){
				params=impressaoPedidoSmart[index];
				if (!params.IDUTILIMPFRONT) {
					var texto = '';
					if ((impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '25' && !!window.cordova && !!cordova.plugins.GertecPrinter) || (impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '27' && !!window.ZhCieloAutomation) || impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '28' || (impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '40' && !!window.ZhStoneAutomation) || (impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '38' && !!window.cordova && !!window.cordova.plugins.IntegrationService)) {
						for (var i in impressaoPedidoSmart){
							for (var j in impressaoPedidoSmart[i].comandos){
								texto += impressaoPedidoSmart[i].comandos[j].parameters.text;
								if (!!~impressaoPedidoSmart[i].comandos[j].parameters.text.search('SENHA')) {
									PrinterService.printerCommand(PrinterService.TEXT_COMMAND, texto);
									PrinterService.printerSpaceCommand(2);
									texto = '';
								}
							}
						}
					}
					defer.resolve({message:"",error:false});
					return defer.promise;
				/*} else if (!params.saas && params.IDUTILIMPFRONT) {
					var result = {
						message: "Possui dados a serem impressos pelo terminal mobile",
						error: false
					};
					defer.resolve(result);
					return defer.promise;*/
				} else {
					if (!Array.isArray(params)) {
						if (params.comandos) {
							params = [params];
						} else {
							params = _.toArray(params);
						}
					}
					params.map(function (param) {
						if(!(param.impressora.DSIPPONTE)){
							ScreenService.showMessage("Impressora "+(param.impressora.NMIMPRLOJA)+" sem endereço do Perifericos cadastrado.");
						} else {
						if(param.impressora.DSIPPONTE.indexOf('http')<0){
							param.impressora.DSIPPONTE = 'http://'+param.impressora.DSIPPONTE;
						}
						var stDSIPPONTE = param.impressora.DSIPPONTE;
						var url = param.impressora.DSIPPONTE + "/print";
						var body = JSON.stringify({
							printerInfo: {
								printerType: param.impressora.IDMODEIMPRES,
								port: param.impressora.CDPORTAIMPR
							},
							commands: param.comandos
						});
						promiseArray.push(
							fetch(
								url, {
									headers: header,
									method: POST,
									body: body
								}
							).then(function (response) {
								if(response && response.text ){
									return response.text().then(function(r){
										response = r;
										try {
											response = JSON.parse(response);
										} catch (error) {
											response.message = 'Não foi possível comunicar com a impressora.';
											response.error = true;
										}
										if(response.error){
											ScreenService.alertNotification(response.message);
										}
									});
								}
							}).catch(function (error) {
								error.message = 'Não foi possível comunicar com a impressora.';
								ScreenService.alertNotification(error.message);
								self.verificaInsecureContent(stDSIPPONTE);
							})
						);
						}
					});
				}
			});
			return Promise.all(promiseArray);
		} catch (error) {
			if (!_.isEmpty(_.get(impressaoPedidoSmart, 'impressora.NMIMPRLOJA'))) {
				error.message = 'Não foi possível comunicar com a impressora. <br><br>' + impressaoPedidoSmart.impressora.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
			} else {
				error.message = 'Não foi possível comunicar com a impressora. <br><br>' + impressaoPedidoSmart.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
			}
			error.error = true;
			defer.reject(error);
			return defer.promise;
		} finally {
			ScreenService.hideLoader();
		}
	};

	this.test = function (params) {
		WindowService.log("call testPerifericos params: "+JSON.stringify(params));
		ScreenService.showLoader();
		var body = JSON.stringify({
			printerInfo: {
				printerType: params.IDMODEIMPRES,
				port: params.CDPORTAIMPR
			}
		});

		var options = {
			headers: header,
			method: POST,
			body: body
		};
		if(!(params.DSIPPONTE)){
			ScreenService.showMessage("Impressora "+(params.NMIMPRLOJA)+" sem endereço do Perifericos cadastrado.");
			error.message = 'Não foi possível comunicar com a impressora. <br><br>' + params.NMIMPRLOJA + "Impressora "+(param.impressora.NMIMPRLOJA)+" sem endereço do Perifericos cadastrado.";
			error.error = true;
			return error;
		}
		if(params.DSIPPONTE.indexOf('http')<0){
			params.DSIPPONTE = 'http://'+params.DSIPPONTE;
		}
		var stDSIPPONTE = params.DSIPPONTE;
		const url = params.DSIPPONTE + "/test";
		return fetch(url, options).then(function (response) {
			if(response && response.text ){
				return response.text().then(function(r){
					response = r;
					try {
						response = JSON.parse(response);
					} catch (error) {
						response.message = 'Não foi possível comunicar com a impressora. <br><br>' + params.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
						response.error = true;
					}
					return response;
				});
			} else {
				if(!response){
					response.message = 'Não houve retorno do Perifericos. <br><br>' + params.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
					response.error = true;
				}
				if(response.error){
					response.error = true;
					var msg = 'Não foi possível comunicar com a impressora. <br><br>';
					if(response.message){
						msg = msg + response.message;
					}
					response.message = msg;
				}
			}
			return response;
		}).catch(function (error) {
			error.message = 'Não foi possível comunicar com a impressora. <br><br>' + params.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
			error.error = true;
			self.verificaInsecureContent(stDSIPPONTE);
			return error;
		}).finally(function () {
			ScreenService.hideLoader();
		});
	};

	this.verificaInsecureContent = function(stDSIPPONTE){
		// Ao fazer uma requisição de uma pagina HTTPS para outra HTTP o navegador bloqueia essa requisição.
		// (blocked:mixed-content)
		return new Promise(function (resolve) {
			if(window.location.href.indexOf('https://')>=0 && stDSIPPONTE){
				var $xhr = $.get(stDSIPPONTE)
				.success(function(){ resolve(); })
				.error(function() {
					if (!$xhr.getAllResponseHeaders()) {
						if ($xhr.readyState == 0) {
							//window.open('chrome://settings/content/siteDetails?site='+window.location.origin, '_blank');
							console.log("A requisição para o Perifericos não foi executada, verifique se o endereço "+stDSIPPONTE+" esta correto e se o serviço do Perifericos esta sendo executado.");
							console.log("A requisição para o Perifericos não foi executada, verifique se o navegador esta bloqueando a requisição. No canto superior esquerdo do navegador, clique no Cadeado. Depois em Configurações do Site e procure pela opção Conteúdo Não Seguro e selecione Permitir.");
						}
					}
					resolve();
				});
			} else {
				resolve();
			}
		});
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register("PerifericosService", PerifericosService);
});